Attribute VB_Name = "ModNormalize"
Option Explicit

Sub Normalize_Data()
Dim shS As Worksheet            ' Source data Sheet
Dim shN As Worksheet            ' Normailized data sheet
Dim i_S As Long                 ' Row index source sheet
Dim j_S As Long                 ' Column index source sheet
Dim j_N As Long                 ' column index normal sheet
Dim SourceName As String        ' Source Sheet Name
Dim NormalName As String        ' Normalized sheet name
Dim ColSave() As String         ' Columns to save
Dim StartColS As Long           ' Start Save Coulmn
Dim EndColS As Long             ' End Save Column
Dim LRowS As Long               ' Last row source sheet
Dim LColS As Long               ' Last column source sheet
Dim RownumN As Long             ' Row number normalized sheet

Application.DisplayAlerts = False

' Initialize variables
ColSave = Split(Sheets("Control Panel").Range("B1"), ":")
StartColS = Asc(UCase(ColSave(0))) - 64
EndColS = Asc(UCase(ColSave(1))) - 64
SourceName = Sheets("Control Panel").Range("B2")
NormalName = Sheets("Control Panel").Range("B3")
RownumN = 2

' Test to see that source sheet exists
If SheetExist(SourceName) = False Then
    MsgBox "The source sheet, " & SourceName & " does not exist." & Chr(10) & _
        "Please rename the sheet or modify cell B2.", vbOKOnly, "Sheet does not exist"
    Exit Sub
Else
    Set shS = Sheets(SourceName)
    LRowS = shS.Range("A" & Rows.Count).End(xlUp).Row
    LColS = shS.Cells(1, Columns.Count).End(xlToLeft).Column
End If

' Test to see if desitnation sheet exists
If SheetExist(NormalName) = True Then
    ' delete it
    Sheets(NormalName).Delete
End If

' Create the desitination sheet
Sheets.Add after:=Sheets(Sheets.Count)
ActiveSheet.Name = NormalName
Set shN = Sheets(NormalName)

' Copy headers to Normalized sheet
For j_S = StartColS To EndColS
    shN.Cells(1, j_S) = shS.Cells(1, j_S)
Next
shN.Cells(1, j_S) = "Metric"
shN.Cells(1, j_S + 1) = "Value"

' Normalize the data
For i_S = 2 To LRowS
    For j_S = EndColS + 1 To LColS
        If shS.Cells(i_S, j_S) <> "" Then
            ' copy preserved columns
            For j_N = StartColS To EndColS
                shN.Cells(RownumN, j_N) = shS.Cells(i_S, j_N)
            Next j_N
            ' Add the metric name
            shN.Cells(RownumN, j_N) = shS.Cells(1, j_S)
            ' add the Value
            shN.Cells(RownumN, j_N + 1) = shS.Cells(i_S, j_S)
            RownumN = RownumN + 1
        End If
    Next j_S
Next i_S
            


Application.DisplayAlerts = True
End Sub

Function SheetExist(SheetName As String) As Boolean
Dim sh As Worksheet     ' pointer to sheets in the workbook

For Each sh In ActiveWorkbook.Sheets
    If sh.Name = SheetName Then
        SheetExist = True
        Exit Function
    End If
Next sh
SheetExist = False
End Function
